<?php
session_start();
require_once "laspinner.php";
new LinkAutomatic();

class LinkAutomatic {
    
    var $plugin_name = "link_automatic";
    var $plugin_name2 = "Link Automatic";
    var $db_table;
    var $db_table2;
	var $spinner;
    function LinkAutomatic() {
		$this->spinner = new Spinner();
        $this->db_table = $this->plugin_name."_group";
        $this->db_table2 = $this->plugin_name."_email_address";
        add_action( 'load-post.php', array(&$this, 'customPostBoxSetup') );
        add_action( 'load-post-new.php', array(&$this, 'customPostBoxSetup') );
        add_action('admin_menu', array(&$this,'createMenu') );
    }

    function customPostBoxSetup() {
        add_action( 'add_meta_boxes', array(&$this, 'addCustomPostBox') );
        add_action( 'add_meta_boxes', array(&$this, 'addCustomPostTextBeforeBox') );
        //add_action( 'add_meta_boxes', array(&$this, 'addCustomPostSpunBox') );
        add_action( 'add_meta_boxes', array(&$this, 'addCustomPostTextAfterBox') );
        add_action( 'save_post', array(&$this, 'customPostBoxSaveHandler'), 10, 2 );
    }
    
    function customPostBoxSaveHandler( $postID, $post ) {
        if ( !isset( $_POST["$this->plugin_name"."_nonce"] ) || !wp_verify_nonce( $_POST["$this->plugin_name"."_nonce"], basename( __FILE__ ) ) ) {
            return $postID; 
        }
        
        $postType = get_post_type_object( $post->post_type );

        if ( !current_user_can( $postType->cap->edit_post, $postID ) ) {
            return $postID;
        }
        
        $newMetaValue = ( isset( $_POST["{$this->plugin_name}_send_to_newsletter"] ) ? sanitize_html_class( $_POST["{$this->plugin_name}_send_to_newsletter"] ) : '' );
        $metaKey = "{$this->plugin_name}_send_to_newsletter";
        update_post_meta( $postID, $metaKey, $newMetaValue );
		
        $metaKey = "{$this->plugin_name}_use_global_pre_and_post_text";
        $newMetaValue = ( isset( $_POST["{$this->plugin_name}_use_global_pre_and_post_text"] ) ? 1 : 0 );
        update_post_meta( $postID, $metaKey, $newMetaValue );
		
		$metaKey = "text_before";
        $newMetaValue = $_POST["{$this->plugin_name}_text_before"];
        update_post_meta( $postID, $metaKey, $newMetaValue );
		
		$metaKey = "text_after";
        $newMetaValue = $_POST["{$this->plugin_name}_text_after"];
        update_post_meta( $postID, $metaKey, $newMetaValue );
    }
    
    function addCustomPostBox() {
	add_meta_box(
            $this->plugin_name."_custom_box",
            $this->plugin_name2,
            array(&$this, "createCustomPostBox"),
            "post",
            "side",
            "default"
	);
    }
    
    function addCustomPostTextBeforeBox() {
	add_meta_box(
            $this->plugin_name."_custom_textbefore_box",
            $this->plugin_name2." - Text before post content",
            array(&$this, "createCustomPostTextBeforeBox"),
            "post",
            "normal",
            "default"
	);
    }
	/*
    function addCustomPostSpunBox() {
	add_meta_box(
            $this->plugin_name."_custom_spun_box",
            $this->plugin_name2." - Spun Post Preview",
            array(&$this, "createCustomPostSpunBox"),
            "post",
            "normal",
            "default"
	);
    }
    */
    function addCustomPostTextAfterBox() {
	add_meta_box(
            $this->plugin_name."_custom_textafter_box",
            $this->plugin_name2." - Text after post content",
            array(&$this, "createCustomPostTextAfterBox"),
            "post",
            "normal",
            "default"
	);
    }
	
    function createCustomPostBox( $object, $box ) {
        wp_nonce_field( basename( __FILE__ ), "$this->plugin_name"."_nonce" );
        $sendToNewsletter = get_post_meta($object->ID, "{$this->plugin_name}_send_to_newsletter", true );
        $useGlobalPrePostText = get_post_meta($object->ID, "{$this->plugin_name}_use_global_pre_and_post_text", true );
        ?>
	<p>
            <input type="checkbox" name="<?php echo "{$this->plugin_name}_send_to_newsletter";?>" id="sendToNewsletter" <?php echo $sendToNewsletter!=""?"checked":""; ?> size="30" />
            <label for="sendToNewsletter">Send to Newsletter</label>
            <br />
            <input type="checkbox" name="<?php echo "{$this->plugin_name}_use_global_pre_and_post_text";?>" id="useGlobalPrePostText" <?php echo $useGlobalPrePostText==1?"checked":""; ?> size="30" />
            <label for="useGlobalPrePostText">Use global pre text and post text</label>
	</p>
        <?php
    }
    /*
    function createCustomPostSpunBox( $object, $box ) {
        wp_nonce_field( basename( __FILE__ ), "$this->plugin_name"."_nonce" );
        $spunVersion = get_post_meta($object->ID, "spun_version", true );
        ?>
	<script type="text/javascript">
		jQuery(document).ready( function() {
			jQuery("#la_spin_button").click( function(event) {
				var plugin_url = jQuery('#la_plugin_url').val();
				jQuery.ajax( {url: plugin_url+"?func=spin&post_id=<?php echo $object->ID; ?>", success: function(ret_val){
					jQuery( "#la_spun_post_ta" ).val(ret_val);
				}, async:false} );
				return false;
			});
		});
	</script>
	<p>
            <p class="submit" style="float:left; padding-left:0; margin-bottom:10px;"><input type="submit" id="la_spin_button" name="la_spin_button" value="Spin"/></p>
			<div style="clear:both;"></div>
            <textarea id="la_spun_post_ta" name="<?php echo "{$this->plugin_name}_spun_version";?>" style="width:100%;" rows="12"><?php echo $spunVersion; ?></textarea>
			<input type="hidden" id="la_plugin_url" value="<?php echo plugins_url('/linkautomatic/jfunctions.php'); ?>"/>
	</p>
        <?php
    }
    */
    function createCustomPostTextBeforeBox( $object, $box ) {
        wp_nonce_field( basename( __FILE__ ), "$this->plugin_name"."_nonce" );
        $textBefore = get_post_meta($object->ID, "text_before", true );
        ?>
	<script type="text/javascript">
		jQuery(document).ready( function() {
			jQuery("#la_textbefore_spin_button").click( function(event) {
				var plugin_url = jQuery('#la_plugin_url').val();
				jQuery.ajax( {url: plugin_url+"?func=spinTextBefore&post_id=<?php echo $object->ID; ?>", success: function(ret_val){
					jQuery( "#la_spun_textbefore_ta" ).val(ret_val);
				}, async:false} );
				return false;
			});
		});
	</script>
	<p>
            <p class="submit" style="float:left; padding-left:0; margin-bottom:10px;"><input type="submit" id="la_textbefore_spin_button" name="la_textbefore_spin_button" value="Spin"/></p>
			<div style="clear:both;"></div>
            <textarea id="la_spun_textbefore_ta" name="<?php echo "{$this->plugin_name}_text_before";?>" style="width:100%;" rows="12"><?php echo $textBefore; ?></textarea>
			<input type="hidden" id="la_plugin_url" value="<?php echo plugins_url('/linkautomatic/jfunctions.php'); ?>"/>
	</p>
        <?php
    }
    
    function createCustomPostTextAfterBox( $object, $box ) {
        wp_nonce_field( basename( __FILE__ ), "$this->plugin_name"."_nonce" );
        $textAfter = get_post_meta($object->ID, "text_after", true );
        ?>
	<script type="text/javascript">
		jQuery(document).ready( function() {
			jQuery("#la_textafter_spin_button").click( function(event) {
				var plugin_url = jQuery('#la_plugin_url').val();
				jQuery.ajax( {url: plugin_url+"?func=spinTextAfter&post_id=<?php echo $object->ID; ?>", success: function(ret_val){
					jQuery( "#la_spun_textafter_ta" ).val(ret_val);
				}, async:false} );
				return false;
			});
		});
	</script>
	<p>
            <p class="submit" style="float:left; padding-left:0; margin-bottom:10px;"><input type="submit" id="la_textafter_spin_button" name="la_textafter_spin_button" value="Spin"/></p>
			<div style="clear:both;"></div>
            <textarea id="la_spun_textafter_ta" name="<?php echo "{$this->plugin_name}_text_after";?>" style="width:100%;" rows="12"><?php echo $textAfter; ?></textarea>
			<input type="hidden" id="la_plugin_url" value="<?php echo plugins_url('/linkautomatic/jfunctions.php'); ?>"/>
	</p>
        <?php
    }
    
    function createMenu() {
        $dir = $this->plugin_name;
    
        add_menu_page("{$this->plugin_name2} Options", "{$this->plugin_name2}", 'administrator', $dir.'/general_settings', array(&$this,'createSettingsPage') );
        add_submenu_page($dir.'/general_settings', 'General Settings', 'General Settings', 'administrator', $dir.'/general_settings', array(&$this,'createSettingsPage') );
        add_submenu_page($dir.'/general_settings', 'Blogs', 'Blogs', 'administrator', $dir.'/blog_settings', array(&$this,'createBlogOptionsPage') );
        add_submenu_page($dir.'/general_settings', 'Media', 'Media', 'administrator', $dir.'/media_settings', array(&$this,'createMediaOptionsPage') );
        add_submenu_page($dir.'/general_settings', 'Other', 'Other', 'administrator', $dir.'/other_settings', array(&$this,'createOtherOptionsPage') );
            
        add_action('admin_init', array(&$this,'init'));

        $options = get_option("{$this->plugin_name}_options");
        if($options['fireEvent'] == True) {
            add_action('publish_page',array(&$this,'email'));
            add_action('future_to_publish', array(&$this,'email'), 10, 1);
            add_action('publish_post',array(&$this,'email'));
        } else {
            add_action('future_to_publish', array(&$this,'email'), 10, 1);
            add_action('new_to_publish',array(&$this,'email'));
            add_action('draft_to_publish',array(&$this,'email'));
        }
            
        $this->handlePostRequest();
    }

    function handlePostRequest() {
        $options = get_option("{$this->plugin_name}_api_options");
        global $wpdb;
        if($_GET['nl_action_id']==3 && isset($_GET['nl_social_network']) ) {
            if($_GET['nl_social_network']=='facebook') {
                $options['fb_account'] = array();
                update_option("{$this->plugin_name}_api_options", $options);
                wp_redirect("admin.php?page={$this->plugin_name}_api_settings");
                exit(1);
            }
            if($_GET['nl_social_network']=='linkedin') {
                $options['linkedin_account'] = array();
                update_option("{$this->plugin_name}_api_options", $options);
                wp_redirect("admin.php?page={$this->plugin_name}_api_settings");
                exit(1);
            }
            if($_GET['nl_social_network']=='twitter') {
                $options['twitter_account'] = array();
                update_option("{$this->plugin_name}_api_options", $options);
                wp_redirect("admin.php?page={$this->plugin_name}_api_settings");
                exit(1);
            }
            if($_GET['nl_social_network']=='plerb') {
                $options['plerb_account'] = array();
                update_option("{$this->plugin_name}_api_options", $options);
                wp_redirect("admin.php?page={$this->plugin_name}_api_settings");
                exit(1);
            }
            if($_GET['nl_social_network']=='identica') {
                $options['identica_account'] = array();
                update_option("{$this->plugin_name}_api_options", $options);
                wp_redirect("admin.php?page={$this->plugin_name}_api_settings");
                exit(1);
            }
            if($_GET['nl_social_network']=='friendfeed') {
                $options['friendfeed_account'] = array();
                update_option("{$this->plugin_name}_api_options", $options);
                wp_redirect("admin.php?page={$this->plugin_name}_api_settings");
                exit(1);
            }
        }
        
        if( isset($_POST['nl_api_update']) ) {
            $post = $_POST["{$this->plugin_name}"];
            $options['fb_application_id'] = $post['fb_application_id'];
            $options['fb_application_secret'] = $post['fb_application_secret'];

            $options['linkedin_api_key'] = $post['linkedin_api_key'];
            $options['linkedin_secret_key'] = $post['linkedin_secret_key'];
            
            $options['twitter_consumer_key'] = $post['twitter_consumer_key'];
            $options['twitter_consumer_secret'] = $post['twitter_consumer_secret'];
            $options['twitter_access_token'] = $post['twitter_access_token'];
            $options['twitter_access_token_secret'] = $post['twitter_access_token_secret'];
            
            $options['plerb_username'] = $post['plerb_username'];
            $options['plerb_password'] = $post['plerb_password'];
            $options['plerb_api_key'] = $post['plerb_api_key'];

            $options['identica_consumer_key'] = $post['identica_consumer_key'];
            $options['identica_consumer_secret'] = $post['identica_consumer_secret'];
            $options['identica_callback_url'] = $post['identica_callback_url'];
            
            $options['friendfeed_username'] = $post['friendfeed_username'];
            $options['friendfeed_remote_key'] = $post['friendfeed_remote_key'];
            
            $twitter_account['social_network'] = 'Twitter';
            $twitter_account['access_token'] = $post['twitter_access_token'];
            $twitter_account['access_token_secret'] = $post['twitter_access_token_secret'];
            $options['twitter_account'] = $twitter_account;
            
            $plerb_account['social_network'] = 'Plerb';
            $plerb_account['username'] = $post['plerb_username'];
            $plerb_account['password'] = $post['plerb_password'];
            $plerb_account['api_key'] = $post['plerb_api_key'];
            $options['plerb_account'] = $plerb_account;
            
            $friendfeed_account['social_network'] = 'FriendFeed';
            $friendfeed_account['username'] = $post['friendfeed_username'];
            $friendfeed_account['remote_key'] = $post['friendfeed_remote_key'];
            $options['friendfeed_account'] = $friendfeed_account;
            
            $options['social_network_facebook'] = $post['social_network_facebook'];
            $options['social_network_linkedin'] = $post['social_network_linkedin'];
            $options['social_network_twitter'] = $post['social_network_twitter'];
            $options['social_network_plerb'] = $post['social_network_plerb'];
            $options['social_network_identica'] = $post['social_network_identica'];
            $options['social_network_friendfeed'] = $post['social_network_friendfeed'];

			
			$options['qaiku_username'] = $post['qaiku_username'];
            $options['qaiku_password'] = $post['qaiku_password'];
			$options['qaiku_apikey'] = $post['qaiku_apikey'];
            $options['qaiku_contentFormat'] = $post['qaiku_contentFormat'];			
			
            update_option("{$this->plugin_name}_api_options", $options);
            wp_redirect("admin.php?page={$this->plugin_name}_api_settings");
            exit(1);
        }
        
        if( isset($_POST['nl_newsletter_group_update']) ) {
            $post = $_POST[$this->plugin_name];
            $new_group_name = $post['group_name'];
            $custom_text = $post['custom_text'];
            if( !empty($new_group_name) ) {
                if( $_POST['nl_newsletter_group_update']=='Edit' ) {
                    $wpdb->query($wpdb->prepare("UPDATE {$this->db_table} SET group_name=%s, custom_text=%s WHERE id=%d",$new_group_name, $custom_text, $post['group_id']));
                } else {
                    $wpdb->query($wpdb->prepare("INSERT IGNORE INTO {$this->db_table} VALUES (NULL, %s, %s, 'y', '')", $new_group_name, $custom_text) );
                }
            }
            wp_redirect("admin.php?page=link_automatic_newsletter_settings&nl_action_id=1&nlpage=groups");
            exit(1);
        }
        
        if( isset($_POST['nl_newsletter_email_address_update']) ) {
            $post = $_POST[$this->plugin_name];
            $new_email_address = $post['email_address'];
            $new_email_name = $post['email_name'];
            
            
            if( $_POST['nl_newsletter_email_address_update']=='Edit' ) {
                $wpdb->query($wpdb->prepare("UPDATE {$this->db_table2} SET email_address=%s, email_name=%s WHERE id=%d",$new_email_address, $new_email_name, $post['email_address_id']));
            } else {
                if( !empty($new_email_address) && !empty($new_email_name) ) {
                    $wpdb->query($wpdb->prepare("INSERT IGNORE INTO {$this->db_table2} VALUES (NULL, %d, %s, %s, 'y', '')",$post['email_address_group_id'], $new_email_address, $new_email_name) );
                }
                $filename = trim($_FILES['upload_csv']['name']);
                if(!empty($filename)) {
                   $ext = end(explode(".", $filename));
                   if( $ext == 'csv') {
                       $handle = fopen($_FILES['upload_csv']['tmp_name'], "r");
                       if( $handle ) {
                           $contents = fread($handle, filesize($_FILES['upload_csv']['tmp_name']));
                           fclose($handle);
                           $data = $this->parseCSV($contents);
                           if( is_array($data) ) {
                               if( count($data) > 0  ) {
                                   $query = "INSERT IGNORE INTO {$this->db_table2} VALUES ";
                                   for( $r=0; $r<count($data); $r++ ) {
                                       $values[] = "(NULL, {$post['email_address_group_id']}, '".trim($data[$r][0])."','".trim($data[$r][1])."', 'y', '')";
                                   }
                                   $query.= implode(",", $values);
                                   $wpdb->query($query);
                               }
                           }
                       }
                   }
                }
            }
            wp_redirect("admin.php?page=link_automatic_newsletter_settings&nl_action_id=1&nlpage=email_addresses&group_id=".$post['email_address_group_id']);
            exit(1);
        }
        if( $_GET['nl_action_id']==3 && $_GET['nlpage']=='email_addresses') {
            $wpdb->query("DELETE FROM {$this->db_table2} WHERE id=".$_GET['email_address_id']);
            wp_redirect("admin.php?page=link_automatic_newsletter_settings&nl_action_id=1&nlpage=email_addresses&group_id=".$_GET['group_id']);
            exit(1);
        }
        if( $_GET['nl_action_id']==3 && $_GET['nlpage']=='groups') {
            $group_id = $_GET['group_id'];
            if(is_numeric($group_id)) {
                $wpdb->query("DELETE FROM `link_automatic_email_address` WHERE group_id=$group_id");
                $wpdb->query("DELETE FROM `link_automatic_group` WHERE id=$group_id");
            }
            wp_redirect("admin.php?page=link_automatic_newsletter_settings&nl_action_id=1&nlpage=groups");
            exit(1);
        }
        if( $_GET['nl_action_id']==4 && $_GET['nlpage']=='groups') {
            $group_id = $_GET['group_id'];
            if(is_numeric($group_id)) {
                $wpdb->query("UPDATE $this->db_table SET active='y' WHERE id=$group_id");
            }
            wp_redirect("admin.php?page=link_automatic_newsletter_settings&nl_action_id=1&nlpage=groups");
            exit(1);
        }
        if( $_GET['nl_action_id']==5 && $_GET['nlpage']=='groups') {
            $group_id = $_GET['group_id'];
            if(is_numeric($group_id)) {
                $wpdb->query("UPDATE $this->db_table SET active='n' WHERE id=$group_id");
            }
            wp_redirect("admin.php?page=link_automatic_newsletter_settings&nl_action_id=1&nlpage=groups");
            exit(1);
        }
        if( isset($_POST['group_apply']) ) {
            $group_ids = $_POST["$this->plugin_name"."_group_ids"];
            $action = $_POST['group_bulk_action'];
            if( is_array($group_ids) ) {
                global $wpdb;
                foreach( $group_ids as $key => $val ) {
                    $id_arr = explode("_",$key);
                    $id = $id_arr[1];
                    if( is_numeric($id) ) {
                        if( $action == 'delete' ) {
                            $delete_ids[] = "id = $id";
                        } else {
                            if( $action == 'enable' ) {
                                $active_value = 'y';
                            } else if( $action == 'disable' ) {
                                $active_value = 'n';
                            }
                            $wpdb->query("UPDATE $this->db_table SET active='$active_value' WHERE id=$id");
                        }
                    }
                }
                if( is_array($delete_ids) ) {
                    if( !empty($delete_ids) && $action=='delete' ) {
                        $query = "DELETE FROM $this->db_table WHERE ".implode(" or ", $delete_ids);
                        $wpdb->query($query);
                    }
                }
            }
            wp_redirect("admin.php?page=link_automatic_newsletter_settings&nl_action_id=1&nlpage=groups");
            exit(1);
        }
        
        if( isset($_POST['email_address_apply']) ) {
            $email_address_ids = $_POST["$this->plugin_name"."_email_address_ids"];
            $action = $_POST['email_address_bulk_action'];
            if( is_array($email_address_ids) ) {
                global $wpdb;
                foreach( $email_address_ids as $key => $val ) {
                    $id_arr = explode("_",$key);
                    $id = $id_arr[2];
                    if( is_numeric($id) ) {
                        if( $action == 'delete' ) {
                            $delete_ids[] = "id = $id";
                        }
                    }
                }
                if( is_array($delete_ids) ) {
                    if( !empty($delete_ids) && $action=='delete' ) {
                        $query = "DELETE FROM $this->db_table2 WHERE ".implode(" or ", $delete_ids);
                        $wpdb->query($query);
                    }
                }
            }
            wp_redirect("admin.php?page=link_automatic_newsletter_settings&nl_action_id=1&nlpage=email_addresses&group_id=".$_POST["$this->plugin_name"]["email_address_group_id"]);
            exit(1);
        }
    }
    
    function curlData($url){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        $data = curl_exec($ch);
        curl_close($ch);
        return $data;
        
    }

    function getHREFs($post){
        $post2 = stripslashes($post);

        if(!preg_match_all("/(<a.*>)(.*)(<\/a>)/ismU",$post2,$matches,PREG_SET_ORDER)){
            return $post;
        }

        foreach($matches as $key => $value){
            
            preg_match("/href\s*=\s*[\'|\"]\s*(.*)\s*[\'|\"]/i",$value[1],$href);
            if((substr($href[1],0,7)!="http://" && substr($href[1],0,8)!="https://") ){
                unset($matches[$key]);
            }else{
                $temp_href = $href[1];
                $arr = explode(" ", $temp_href);
                if( $arr ) {
                    if( !empty($arr) ) {
                        $temp_href = $arr[0];
                        $temp_href = str_replace("\"","",$temp_href);
                        $href_arr[] = $temp_href;
                    }
                }
            }
        }
        return $href_arr;
    }
    
    function stripTags($post){
        $post2 = stripslashes($post);

        if(!preg_match_all("/(<a.*>)(.*)(<\/a>)/ismU",$post2,$matches,PREG_SET_ORDER)){
            return $post;
        }

        foreach($matches as $key => $value){
            
            preg_match("/href\s*=\s*[\'|\"]\s*(.*)\s*[\'|\"]/i",$value[1],$href);
            if((substr($href[1],0,7)!="http://" && substr($href[1],0,8)!="https://") ){
                unset($matches[$key]);
            }else{
                $post2 = str_replace($matches[$key][0],$href[1],$post2);
            }
        }
        return $post2;
    }

    function snippet($text='', $count='5') {
        if( empty($text)) {
            return '';
        }
        $arr = explode(' ', $text);
        $total = 0;
        foreach( $arr as $val ) {
            if( $total < $count ) {
                if( !empty($val) ) {
                    $arr2[] = $val;
                    $total++;
                }
            }
        }
        if( !empty($arr2) ) {
            return implode(" ",$arr2)."...";
        }
        return '';
    }
    
    function postRequest($url, $data, $referer='') {

        $data = http_build_query($data);

        $url = parse_url($url);

        if ($url['scheme'] != 'http') { 
            return array();
        }

        $host = $url['host'];
        $path = $url['path'];

        $fp = fsockopen($host, 80, $errno, $errstr, 30);

        if ($fp){
            fputs($fp, "POST $path HTTP/1.1\r\n");
            fputs($fp, "Host: $host\r\n");

            if ($referer != '')
                fputs($fp, "Referer: $referer\r\n");

            fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
            fputs($fp, "Content-length: ". strlen($data) ."\r\n");
            fputs($fp, "Connection: close\r\n\r\n");
            fputs($fp, $data);

            $result = ''; 
            while(!feof($fp)) {
                $result .= fgets($fp, 128);
            }
        } else {
            return array(
                'status' => 'err', 
                'error' => "$errstr ($errno)"
            );
        }

        fclose($fp);

        $result = explode("\r\n\r\n", $result, 2);

        $header = isset($result[0]) ? $result[0] : '';
        $content = isset($result[1]) ? $result[1] : '';

        return array(
            'status' => 'ok',
            'header' => $header,
            'content' => $content
        );
    }

    function doPost($url, $contentArr) {
        try {
            $result = $this->postRequest($url, $contentArr);
        }catch(Exception $e) {
        }
    }

    
    function init(){
        register_setting( "{$this->plugin_name}_options", "{$this->plugin_name}_options", array(&$this,'validate') );
        register_setting( "{$this->plugin_name}_blog_options", "{$this->plugin_name}_blog_options", array(&$this,'validate') );
        register_setting( "{$this->plugin_name}_media_options", "{$this->plugin_name}_media_options", array(&$this,'validate') );
        register_setting( "{$this->plugin_name}_other_options", "{$this->plugin_name}_other_options", array(&$this,'validate') );

        add_settings_section('generalSection', 'General Settings', array(&$this,'setGeneralSectionText'), "{$this->plugin_name}_general_page");

        add_settings_field('allowToSendFrom', 'Allow to Send from', array(&$this,'setAllowToSendFrom'), "{$this->plugin_name}_general_page", 'generalSection');
        add_settings_field('fireEvent', 'Allow Post Update', array(&$this,'setFireEvent'), "{$this->plugin_name}_general_page", 'generalSection');
        add_settings_field('mediaFileSizeMaximum', 'Maximum media file size', array(&$this,'setMaximumMediaFileSize'), "{$this->plugin_name}_general_page", 'generalSection');
        add_settings_field('fromName', 'From Name', array(&$this,'setFromName'), "{$this->plugin_name}_general_page", 'generalSection');
        add_settings_field('fromEmailAdress', 'From Email', array(&$this,'setFromEmailAddress'), "{$this->plugin_name}_general_page", 'generalSection');

        add_settings_field('numberOfCharacters', 'Number of Characters in Post:', array(&$this, 'setNumberOfCharacters'), "{$this->plugin_name}_general_page",'generalSection');
        add_settings_field('linkTag', 'Link Tag', array(&$this,'setLinkTag'), "{$this->plugin_name}_general_page", 'generalSection');
        add_settings_field('linkToShow', 'Choose Link to show', array(&$this, 'setLinkToShow'), "{$this->plugin_name}_general_page", 'generalSection');

        add_settings_field('emailTextBefore', 'Email text before post:', array(&$this, 'setEmailTextBefore'), "{$this->plugin_name}_general_page",'generalSection');
        add_settings_field('emailTextAfter', 'Email text after post:', array(&$this, 'setEmailTextAfter'), "{$this->plugin_name}_general_page",'generalSection');
		
        add_settings_section('blogAccountsSection', '', array(&$this,'setBlogAccountSectionText'), "{$this->plugin_name}_blog_page");
        add_settings_field('accountEmailAddress', 'Accounts', array(&$this,'setAccountEmailAddress'), "{$this->plugin_name}_blog_page", "blogAccountsSection");
        
        add_settings_section('mediaAccountsSection', '', array(&$this,'setMediaAccountSectionText'), "{$this->plugin_name}_media_page");
        add_settings_field('imageEmailAddress', 'Photos', array(&$this,'setImageEmailAddress'), "{$this->plugin_name}_media_page", 'mediaAccountsSection');
        add_settings_field('videoEmailAddress', 'Videos', array(&$this,'setVideoEmailAddress'), "{$this->plugin_name}_media_page", 'mediaAccountsSection');
        add_settings_field('photoVideoEmailAddress', 'Photos and Videos', array(&$this,'setPhotoVideoEmailAddress'), "{$this->plugin_name}_media_page", 'mediaAccountsSection');
        add_settings_field('audioEmailAddress', 'Audios', array(&$this,'setAudioEmailAddress'), "{$this->plugin_name}_media_page", 'mediaAccountsSection');
		
        add_settings_section('otherAccountsSection', '', array(&$this,'setOtherAccountSectionText'), "{$this->plugin_name}_other_page");
        add_settings_field('otherEmailAddress', 'Accounts', array(&$this,'setOtherEmailAddress'), "{$this->plugin_name}_other_page", 'otherAccountsSection');
    }

    function setFireEvent() {
        $options = get_option("{$this->plugin_name}_options"); ?>
        <input id='fireEvent' name='<?php echo "{$this->plugin_name}";?>_options[fireEvent]' type='checkbox' <?php echo isset($options['fireEvent'])?"checked":""; ?> style="padding: 0; margin: 0"/><br />
        <label for='fireEvent'>Allow Posts to be sent out when the Update button is clicked</label>
        <?php
    }

    function setAllowToSendFrom() {        $options = get_option("{$this->plugin_name}_options");        if($options['checkbox_init'] == False ) {            $options['allowToSendFromPages'] = 'on';            $options['allowToSendFromPosts'] = 'on';            $options['checkbox_init'] = True;            update_option("{$this->plugin_name}_options", $options);        }        ?>        <input type="hidden" name="<?php echo "{$this->plugin_name}";?>_options[checkbox_init]" value="<?php echo $options['checkbox_init']; ?>"/>        <input style="margin:0; padding:0" id='allowToSendFromPages' name='<?php echo "{$this->plugin_name}";?>_options[allowToSendFromPages]' type='checkbox' <?php echo isset($options['allowToSendFromPages'])?"checked":""; ?>/><label for="allowToSendFromPages" style="margin: 0 0 0 5px; padding: 0; position: relative; top: 0" for="allowToSendFromPage">Pages</label><br />        <input style="margin:0; padding:0" id='allowToSendFromPosts' name='<?php echo "{$this->plugin_name}";?>_options[allowToSendFromPosts]' type='checkbox' <?php echo isset($options['allowToSendFromPosts'])?"checked":""; ?>/><label for="allowToSendFromPosts" style="margin: 0 0 0 5px" for="allowToSendFromPost">Posts</label>        <?php    }

    function setMaximumMediaFileSize() {
        $options = get_option("{$this->plugin_name}_options");
        $filesize = trim($options['file_size']);
        if(!is_numeric($filesize)) {
            $filesize = 20;
            $options['file_size'] = $filesize;
            update_option("{$this->plugin_name}_options", $options);
        } else {
            if( $filesize < 1 ) {
                $filesize = 20;
                $options['file_size'] = $filesize;
                update_option("{$this->plugin_name}_options", $options);
            }
        }
        echo "<input id='maximumMediaFileSize' name='{$this->plugin_name}_options[file_size]' size='10' type='text' value='{$options['file_size']}' />";
    }

    function setFromName() {
            $options = get_option("{$this->plugin_name}_options");
            echo "<input id='fromName' name='{$this->plugin_name}_options[fromName]' size='40' type='text' value='{$options['fromName']}' />";
    }

    function setFromEmailAddress() {
            $options = get_option("{$this->plugin_name}_options");
            echo "<input id='fromEmailAddress' name='{$this->plugin_name}_options[fromEmailAddress]' size='40' type='text' value='{$options['fromEmailAddress']}' onsubmit='return validateForm();' />";
    }

    function setNumberOfCharacters() {
        $options = get_option("{$this->plugin_name}_options");
        echo "<input id='numberOfCharacters' name='{$this->plugin_name}_options[characters]' size='10' type='text' value='{$options['characters']}' />";
    }

    function setEmailTextBefore() {
        $options = get_option("{$this->plugin_name}_options");
        echo "<textarea rows='5' style='width:500px;' id='emailTextBefore' name='{$this->plugin_name}_options[emailTextBefore]' >{$options['emailTextBefore']}</textArea>";
    }

    function setEmailTextAfter() {
        $options = get_option("{$this->plugin_name}_options");
        echo "<textarea rows='5' style='width:500px;' id='emailTextAfter' name='{$this->plugin_name}_options[emailTextAfter]'>{$options['emailTextAfter']}</textArea>";
    }	
    
    function setLinkTag(){
        $options = get_option("{$this->plugin_name}_options");
        $linktag = isset($options['linktag'])?$options['linktag']:"Read more..."; ?>
        <input id="linkTag" type="text" name="<?php echo "{$this->plugin_name}_options[linktag]";?>" size="40" value="<?php echo $linktag; ?>" />
    <br /><label for="linkTag" >Text to show before any links below</label>
    <?php
    }

    function setLinkToShow() {
        $options = get_option("{$this->plugin_name}_options");
        if(  $options['linkToShow'] != 'sitetitlelink' && $options['linkToShow'] != 'posttitlelink' && $options['linkToShow'] != 'sitetextlink' && $options['linkToShow'] != 'posttextlink' && $options['linkToShow'] != 'homelink' && $options['linkToShow'] != 'postlink' && $options['linkToShow'] != 'nolink' && $options['linkToShow'] != 'customlink' && $options['linkToShow'] != 'randomlink') {
             $options['linkToShow'] = 'nolink';
             update_option("{$this->plugin_name}_options", $options);
        }
        ?>
    
        <script type="text/javascript">
            jQuery(document).ready(function(){
                jQuery("#form1")[0].reset();
                jQuery("#sitetitlelink").click(function(){
                    jQuery("#posttitlelinkspan").hide();
                    jQuery("#sitetextlinkspan").hide();
                    jQuery("#posttextlinkspan").hide();
                    jQuery("#postlinkspan").hide();
                    jQuery("#nolinkspan").hide();
                    jQuery("#customlinkspan").hide();
                    jQuery("#homelinkspan").hide();
                    jQuery("#randomlinkspan").hide();
                    jQuery("#sitetitlelinkspan").show();
                });
                jQuery("#posttitlelink").click(function(){
                    jQuery("#sitetitlelinkspan").hide();
                    jQuery("#sitetextlinkspan").hide();
                    jQuery("#posttextlinkspan").hide();
                    jQuery("#postlinkspan").hide();
                    jQuery("#nolinkspan").hide();
                    jQuery("#customlinkspan").hide();
                    jQuery("#homelinkspan").hide();
                    jQuery("#randomlinkspan").hide();
                    jQuery("#posttitlelinkspan").show();
                });
                jQuery("#sitetextlink").click(function(){
                    jQuery("#sitetitlelinkspan").hide();
                    jQuery("#posttitlelinkspan").hide();
                    jQuery("#posttextlinkspan").hide();
                    jQuery("#postlinkspan").hide();
                    jQuery("#nolinkspan").hide();
                    jQuery("#customlinkspan").hide();
                    jQuery("#homelinkspan").hide();
                    jQuery("#randomlinkspan").hide();
                    jQuery("#sitetextlinkspan").show();
                });
                jQuery("#posttextlink").click(function(){
                    jQuery("#sitetitlelinkspan").hide();
                    jQuery("#posttitlelinkspan").hide();
                    jQuery("#sitetextlinkspan").hide();
                    jQuery("#postlinkspan").hide();
                    jQuery("#nolinkspan").hide();
                    jQuery("#customlinkspan").hide();
                    jQuery("#homelinkspan").hide();
                    jQuery("#randomlinkspan").hide();
                    jQuery("#posttextlinkspan").show();
                });
                jQuery("#homelink").click(function(){
                    jQuery("#sitetitlelinkspan").hide();
                    jQuery("#posttitlelinkspan").hide();
                    jQuery("#sitetextlinkspan").hide();
                    jQuery("#posttextlinkspan").hide();
                    jQuery("#postlinkspan").hide();
                    jQuery("#nolinkspan").hide();
                    jQuery("#customlinkspan").hide();
                    jQuery("#randomlinkspan").hide();
                    jQuery("#homelinkspan").show();
                });
                jQuery("#postlink").click(function(){
                    jQuery("#sitetitlelinkspan").hide();
                    jQuery("#posttitlelinkspan").hide();
                    jQuery("#sitetextlinkspan").hide();
                    jQuery("#posttextlinkspan").hide();
                    jQuery("#customlinkspan").hide();
                    jQuery("#nolinkspan").hide();
                    jQuery("#homelinkspan").hide();
                    jQuery("#randomlinkspan").hide();
                    jQuery("#postlinkspan").show();
                });
                jQuery("#customlink").click(function(){
                    jQuery("#sitetitlelinkspan").hide();
                    jQuery("#posttitlelinkspan").hide();
                    jQuery("#sitetextlinkspan").hide();
                    jQuery("#posttextlinkspan").hide();
                    jQuery("#homelinkspan").hide();
                    jQuery("#postlinkspan").hide();
                    jQuery("#nolinkspan").hide();
                    jQuery("#randomlinkspan").hide();
                    jQuery("#customlinkspan").show();
                });
                jQuery("#randomlink").click(function(){
                    jQuery("#sitetitlelinkspan").hide();
                    jQuery("#posttitlelinkspan").hide();
                    jQuery("#sitetextlinkspan").hide();
                    jQuery("#posttextlinkspan").hide();
                    jQuery("#homelinkspan").hide();
                    jQuery("#postlinkspan").hide();
                    jQuery("#nolinkspan").hide();
                    jQuery("#customlinkspan").hide();
                    jQuery("#randomlinkspan").show();
                });
                jQuery("#nolink").click(function(){
                    jQuery("#sitetitlelinkspan").hide();
                    jQuery("#posttitlelinkspan").hide();
                    jQuery("#sitetextlinkspan").hide();
                    jQuery("#posttextlinkspan").hide();
                    jQuery("#postlinkspan").hide();
                    jQuery("#homelinkspan").hide();
                    jQuery("#customlinkspan").hide();
                    jQuery("#randomlinkspan").hide();
                    jQuery("#nolinkspan").show();
                });
            });
        </script>

        <input type='radio' id="sitetitlelink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='sitetitlelink' <?php checked( $options['linkToShow'], "sitetitlelink" );?> />
        <label for="sitetitlelink">Site Title Link &nbsp;</label>
    
        <input type='radio' id="posttitlelink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='posttitlelink' <?php checked( $options['linkToShow'], "posttitlelink" );?> />
        <label for="posttitlelink">Post Title Link &nbsp;</label>
    
        <input type='radio' id="sitetextlink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='sitetextlink' <?php checked( $options['linkToShow'], "sitetextlink" );?> />
        <label for="sitetextlink">Site Text Link &nbsp;</label>
    
        <input type='radio' id="posttextlink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='posttextlink' <?php checked( $options['linkToShow'], "posttextlink" ); ?> />
        <label for="posttextlink">Post Text Link &nbsp;</label>
    
        <input type='radio' id="homelink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='homelink' <?php checked( $options['linkToShow'], "homelink" ); ?> />
        <label for="homelink">Home URL &nbsp;</label>
    
        <input type='radio' id="postlink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='postlink' <?php checked( $options['linkToShow'], "postlink" ); ?> />
        <label for="postlink">Post URL &nbsp;</label>
    
        <input type='radio' id="customlink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='customlink' <?php checked( $options['linkToShow'], "customlink" ); ?> />
        <label for="customlink">Custom Link &nbsp;</label>
    
        <input type='radio' id="randomlink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='randomlink' <?php checked( $options['linkToShow'], "randomlink" ); ?> />
        <label for="randomlink">Random link &nbsp;</label>
        
        <input type='radio' id="nolink" name='<?php echo "{$this->plugin_name}_options[linkToShow]";?>' value='nolink' <?php checked( $options['linkToShow'], "nolink" ); ?> />
        <label for="nolink">No link</label>

        <span id="sitetitlelinkspan" style="display:<?php echo $options['linkToShow'] != "sitetitlelink"?'none':''; ?>"><br /><b><i>You are using post title for the site URL..</i></b></span>
        <span id="posttitlelinkspan" style="display:<?php echo $options['linkToShow'] != "posttitlelink"?'none':''; ?>"><br /><b><i>You are using post title for the post URL..</i></b></span>
        <span id="sitetextlinkspan" style="display:<?php echo $options['linkToShow'] != "sitetextlink"?'none':''; ?>">
            <br /><input type="text" name="<?php echo "{$this->plugin_name}_options[sitetextlinkfield]";?>" value="<?php echo $options['sitetextlinkfield']; ?>" /> 
            &nbsp; This will link to your homepage
        </span>
        <span id="posttextlinkspan" style="display:<?php echo $options['linkToShow'] != "posttextlink"?'none':''; ?>">
            <br /><input type="text" name="<?php echo "{$this->plugin_name}_options[posttextlinkfield]";?>" value="<?php echo $options['posttextlinkfield']; ?>" />
            &nbsp; This will link to your post page
        </span>
        <span id="homelinkspan" style="display:<?php echo $options['linkToShow'] != "homelink"?'none':''; ?>"><br /><b><i>You are using home URL for the link..</i></b></span>
        <span id="postlinkspan" style="display:<?php echo $options['linkToShow'] != "postlink"?'none':''; ?>"><br /><b><i>You are using post URL for the link..</i></b></span>
        <span id="customlinkspan" style="display:<?php echo $options['linkToShow'] != "customlink"?'none':''; ?>">
            <br />
            <label style="margin: 0 5px 0 0" for="custom_link_url">URL</label><input id="custom_link_url" type="text" name="<?php echo "{$this->plugin_name}_options[custom_link_url]";?>" value="<?php echo $options['custom_link_url']; ?>" size="40"/> 
            <label style="margin: 0 5px 0 10px" for="custom_link_text">Text</label><input id="custom_link_text" type="text" name="<?php echo "{$this->plugin_name}_options[custom_link_text]";?>" value="<?php echo $options['custom_link_text']; ?>" size="40" />
        </span>
        <div style="clear: both"></div>
        <span id="randomlinkspan" style="display:<?php echo $options['linkToShow'] != "randomlink"?'none':''; ?>">
            <label style="position: relative; top: 2px"><b>Text link types to randomize</b></label>
            <ul style="margin-top: 0">
                <li><input id="site_title_link_ch" name="<?php echo "{$this->plugin_name}_options[random][site_title_link_ch]";?>" style="margin: 0 5px 0 0; padding: 0" type="checkbox" <?php echo isset($options['random']['site_title_link_ch'])?"checked":""; ?>/><label for="site_title_link_ch">Site Title Link</label></li>
                <li><input id="post_title_link_ch" name="<?php echo "{$this->plugin_name}_options[random][post_title_link_ch]";?>" style="margin: 0 5px 0 0; padding: 0" type="checkbox" <?php echo isset($options['random']['post_title_link_ch'])?"checked":""; ?>/><label for="post_title_link_ch">Post Title Link</label></li>
                <li><input id="site_text_link_ch" name="<?php echo "{$this->plugin_name}_options[random][site_text_link_ch]";?>" style="margin: 0 5px 0 0; padding: 0" type="checkbox" <?php echo isset($options['random']['site_text_link_ch'])?"checked":""; ?>/><label for="site_text_link_ch">Site Text Link</label></li>
                <li><input id="post_text_link_ch" name="<?php echo "{$this->plugin_name}_options[random][post_text_link_ch]";?>" style="margin: 0 5px 0 0; padding: 0" type="checkbox" <?php echo isset($options['random']['post_text_link_ch'])?"checked":""; ?>/><label for="post_text_link_ch">Post Text Link</label></li>
                <li><input id="home_url_ch" name="<?php echo "{$this->plugin_name}_options[random][home_url_ch]";?>" style="margin: 0 5px 0 0; padding: 0" type="checkbox" <?php echo isset($options['random']['home_url_ch'])?"checked":""; ?>/><label for="home_url_ch">Home URL</label></li>
                <li><input id="post_url_ch" name="<?php echo "{$this->plugin_name}_options[random][post_url_ch]";?>" style="margin: 0 5px 0 0; padding: 0" type="checkbox" <?php echo isset($options['random']['post_url_ch'])?"checked":""; ?>/><label for="post_url_ch">Post URL</label></li>
                <li><input id="custom_link_ch" name="<?php echo "{$this->plugin_name}_options[random][custom_link_ch]";?>" style="margin: 0 5px 0 0; padding: 0" type="checkbox" <?php echo isset($options['random']['custom_link_ch'])?"checked":""; ?>/><label for="custom_link_ch">Custom Link</label></li>
                <li><input id="no_link_ch" name="<?php echo "{$this->plugin_name}_options[random][no_link_ch]";?>" style="margin: 0 5px 0 0; padding: 0" type="checkbox" <?php echo isset($options['random']['no_link_ch'])?"checked":""; ?>/><label for="no_link_ch">No Link</label></li>
            </ul>
        </span>
        <span id="nolinkspan" style="display:<?php echo $options['linkToShow'] != "nolink"?'none':''; ?>"><br /><b><i>No Link..</i></b></span>
    
        <?php
    }

    function setAccountEmailAddress() {
        $options = get_option("{$this->plugin_name}_blog_options");
        $plugin_url = trailingslashit( get_bloginfo('wpurl') ).PLUGINDIR.'/'. dirname( plugin_basename(__FILE__) );
        ?>
        <script type="text/javascript">
            jQuery(document).ready(function() {
                jQuery("#form2")[0].reset();
                jQuery("#selectDeselectAll").click(function(){
                    var val = jQuery(this).attr('checked');
					var checkboxes = jQuery("#form2").find(".blog_checkbox");
					for(var i=0; i<checkboxes.length; i++ ) {
						jQuery(checkboxes[i])[0].checked = val;
					}
                });
            });
        </script>
        
        <table style="margin:0; padding:0">
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input id="selectDeselectAll" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][selectDeselectAll]"; ?>" value="<?php echo $options['blogEmailAddress']['selectDeselectAll']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['selectDeselectAll']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><label for="selectDeselectAll"><b>Select/Deselect All</b></label>&nbsp;&nbsp;</td>
                <td></td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="tumblr_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][tumblr_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['tumblr_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['tumblr_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/tumblr.gif" width="16" height="16"/><label style="position: relative; top: 1px" for="tumblr_checkbox">Tumblr email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][tumblr]"; ?>"
                    value="<?php echo $options['blogEmailAddress']['tumblr']; ?>" style="margin-right:19px;"/> 
                    &nbsp;&nbsp;<a href="http://screencast.com/t/R9erArBeFil" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://www.tumblr.com/" target="_blank" >Link to Sign-up</a></td>
                </tr>
                
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="livejournal_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][livejournal_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['livejournal_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['livejournal_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/livejournal.png" width="16" height="16"/><label style="position: relative; top: 1px" for="livejournal_checkbox">Livejournal email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][livejournal]"; ?>"
                    value="<?php echo $options['blogEmailAddress']['livejournal']; ?>" style="margin-right:19px;" />
                    &nbsp;&nbsp;<a href="http://www.livejournal.com/manage/settings/?cat=mobile" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://www.livejournal.com/create.bml" target="_blank">Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="blogger_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][blogger_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['blogger_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['blogger_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/blogger.png" width="16" height="16"/><label style="position: relative; top: 1px" for="blogger_checkbox">Blogger email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][blogger]"; ?>"
                    value="<?php echo $options['blogEmailAddress']['blogger']; ?>"  style="margin-right:19px;"/>
                    &nbsp;&nbsp;<a href="http://screencast.com/t/NlFkHgWBBZm" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://accounts.google.com/NewAccount?continue=http%3A%2F%2Fwww.blogger.com%2Fhome&hl=en&service=blogger&ltmpl=start" target="_blank">Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="onsugar_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][onsugar_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['onsugar_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['onsugar_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/onsugar.png" width="16" height="16"/><label style="position: relative; top: 1px" for="onsugar_checkbox">Onsugar mail</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][onsugar]"; ?>"
                    value="<?php echo !empty($options['blogEmailAddress']['onsugar']) ? $options['blogEmailAddress']['onsugar'] : ""; ?>"  style="margin-right:19px;"/>
                    &nbsp;&nbsp;<a href="http://screencast.com/t/fE1PINnu1q" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://secure.onsugar.com/user/register?destination=http%3A%2F%2Fhome.onsugar.com%2F%3Ffss%3D1&site=home" target="_blank">Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="ipernity_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][ipernity_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['ipernity_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['ipernity_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/ipernity.png" width="16" height="16"/><label style="position: relative; top: 1px" for="ipernity_checkbox">Ipernity mail</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][ipernity]"; ?>"
                    value="<?php echo !empty($options['blogEmailAddress']['ipernity']) ? $options['blogEmailAddress']['ipernity'] : ""; ?>"  style="margin-right:19px;"/>
                    &nbsp;&nbsp;<a href="https://www.ipernity.com/pref/mailpost" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://www.ipernity.com/subscribe" target="_blank">Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="multiply_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][multiply_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['multiply_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['multiply_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/multiply.png" width="16" height="16"/><label style="position: relative; top: 1px" for="multiply_checkbox">Multiply email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][multiply]"; ?>"
                    value="<?php echo !empty($options['blogEmailAddress']['multiply']) ? $options['blogEmailAddress']['multiply'] : ""; ?>"  style="margin-right:19px;"/>
                    &nbsp;&nbsp;<a href="http://multiply.com/setup#_link_email" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://multiply.com/" target="_blank">Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="myopera_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][myopera_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['myopera_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['myopera_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/myopera.png" width="16" height="16"/><label style="position: relative; top: 1px" for="myopera_checkbox">My Opera email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][myopera]"; ?>"
                    value="<?php echo $options['blogEmailAddress']['myopera']; ?>"  style="margin-right:19px;"/>
                    &nbsp;&nbsp;<a href="http://screencast.com/t/1096TSFAboH" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://my.opera.com/community/signup/" target="_blank">Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="hyves_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][hyves_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['hyves_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['hyves_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/hyves.png" width="16" height="16"/><label style="position: relative; top: 1px" for="hyves_checkbox">Hyves email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][hyves]"; ?>"
                    value="<?php echo $options['blogEmailAddress']['hyves']; ?>"  style="margin-right:19px;"/>
                    &nbsp;&nbsp;<a href="http://www.hyves.nl/profilemanage/settings/personal/" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://www.hyves.nl/create/?auth_currentUrl=http%3A%2F%2Fwww.hyves.nl%2F%3F&current_language_id=1" target="_blank">Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="evernote_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][evernote_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['evernote_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['evernote_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/evernote.png" width="16" height="16"/><label style="position: relative; top: 1px" for="evernote_checkbox">Evernote email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][evernote]"; ?>"
                    value="<?php echo $options['blogEmailAddress']['evernote']; ?>"  style="margin-right:19px;"/>
                    &nbsp;&nbsp;<a href="https://www.evernote.com/Settings.action" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://www.evernote.com/Registration.action" target="_blank">Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="posterous_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][posterous_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['posterous_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['posterous_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0; width:140px"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/posterous.png" width="16" height="16"/><label style="position: relative; top: 1px" for="posterous_checkbox">Posterous email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px; padding:3px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][posterous]"; ?>"
                    value="<?php echo $options['blogEmailAddress']['posterous']; ?>"/>
                    &nbsp;&nbsp;<a href="http://screencast.com/t/ZWq9712C" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://posterous.com/register" target="_blank">Link to Sign-up</a></td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="blog_checkbox" id="wordpress_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][wordpress_checked]"; ?>" value="<?php echo $options['blogEmailAddress']['wordpress_checked']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['wordpress_checked']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0; width:140px"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/wordpress.png" width="16" height="16"/><label style="position: relative; top: 1px" for="wordpress_checkbox">Wordpress email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px; padding:3px;" type="text" name="<?php echo "{$this->plugin_name}_blog_options[blogEmailAddress][wordpress]"; ?>"
                    value="<?php echo $options['blogEmailAddress']['wordpress']; ?>"/> &nbsp;&nbsp;<a
                    href="http://codex.wordpress.org/Settings_Writing_SubPanel#Post_via_e-mail" target="_blank">How to setup post by email</a></td>
            </tr>			
        </table>

        <?php
    }
    
    function setImageEmailAddress() {
        $options = get_option("{$this->plugin_name}_media_options");
        $plugin_url = trailingslashit( get_bloginfo('wpurl') ).PLUGINDIR.'/'. dirname( plugin_basename(__FILE__) );
        ?>
        
        <script type="text/javascript">
            jQuery(document).ready(function() {
                jQuery("#form3")[0].reset();
                jQuery("#selectDeselectAll").click(function(){
                    var val = jQuery(this).attr('checked');
					var checkboxes = jQuery("#form3").find(".media_checkbox");
					for(var i=0; i<checkboxes.length; i++ ) {
						jQuery(checkboxes[i])[0].checked = val;
					}
                });
            });
        </script>
        <table style="margin:0; padding:0">
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input id="selectDeselectAll" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[blogEmailAddress][selectDeselectAll]"; ?>" value="<?php echo $options['blogEmailAddress']['selectDeselectAll']==True?"True":"False" ?>" <?php echo $options['blogEmailAddress']['selectDeselectAll']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><label for="selectDeselectAll"><b>Select/Deselect All</b></label>&nbsp;&nbsp;</td>
                <td></td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="picasa_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][picasa_checked]"; ?>" <?php echo isset($options['photos_email_address']['picasa_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0; width:175px"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/picasa.png" width="16" height="16"/><label style="position: relative; top: 1px" for="picasa_checkbox">Picasa Web Albums email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][picasa]"; ?>"
                    value="<?php echo $options['photos_email_address']['picasa']; ?>"/>
                    &nbsp;&nbsp;<a href="https://picasaweb.google.com/lh/settings" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://accounts.google.com/NewAccount?continue=https://picasaweb.google.com/lh/login?continue=https://picasaweb.google.com/home&hl=en_US&service=lh2&ltmpl=gp" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="lockerz_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][lockerz_checked]"; ?>" <?php echo isset($options['photos_email_address']['lockerz_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/lockerz.png" width="16" height="16"/><label style="position: relative; top: 1px" for="lockerz_checkbox">Lockerz email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][lockerz_txt]";?>"
                    value="<?php echo $options['photos_email_address']['lockerz_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://lockerz.com/settings" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://lockerz.com/signup" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="imageevent_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][imageevent_checked]"; ?>" <?php echo isset($options['photos_email_address']['imageevent_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/imageevent.png" width="16" height="16"/><label style="position: relative; top: 1px" for="imageevent_checkbox">ImageEvent email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][imageevent_txt]";?>"
                    value="<?php echo $options['photos_email_address']['imageevent_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://imageevent.com/support.jsp?x=3001#selectemail" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://imageevent.com/signup.jsp" target="_blank" >Link to Sign-up</a></td>
            </tr>

            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="keepandshare_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][keepandshare_checked]"; ?>" <?php echo isset($options['photos_email_address']['keepandshare_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/keepandshare.png" width="16" height="16"/><label style="position: relative; top: 1px" for="keepandshare_checkbox">KeepandShare email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][keepandshare_txt]"; ?>"
                    value="<?php echo $options['photos_email_address']['keepandshare_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://www.keepandshare.com/htm/help3/photo/emailing.php" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://www.keepandshare.com/business/registration.php?headersignup" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="sugarsync_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][sugarsync_checked]"; ?>" <?php echo isset($options['photos_email_address']['sugarsync_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/sugarsync.png" width="16" height="16"/><label style="position: relative; top: 1px" for="sugarsync_checkbox">SugarSync email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][sugarsync_txt]"; ?>"
                    value="<?php echo $options['photos_email_address']['sugarsync_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://screencast.com/t/eey2WgTTxxE" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://www.sugarsync.com/products/sync_pricing.html" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="kodakgallery_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][kodakgallery_checked]"; ?>" <?php echo isset($options['photos_email_address']['kodakgallery_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/kodakgallery.png" width="16" height="16"/><label style="position: relative; top: 1px" for="kodakgallery_checkbox">Kodak Gallery email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][kodakgallery_txt]"; ?>"
                    value="<?php echo $options['photos_email_address']['kodakgallery_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://www.kodakgallery.com/upload-photos" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://www.kodakgallery.com/gallery/welcome.jsp" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="twitpic_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][twitpic_checked]"; ?>" <?php echo isset($options['photos_email_address']['twitpic_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/twitpic.png" width="16" height="16"/><label style="position: relative; top: 1px" for="twitpic_checkbox">Twitpic email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][twitpic_txt]"; ?>"
                    value="<?php echo $options['photos_email_address']['twitpic_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://twitpic.com/account/settings/mobile" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://twitpic.com/session/new" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="tribalpages_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][tribalpages_checked]"; ?>" <?php echo isset($options['photos_email_address']['tribalpages_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/tribalpages.png" width="16" height="16"/><label style="position: relative; top: 1px" for="tribalpages_checkbox">TribalPages email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][tribalpages_txt]"; ?>"
                    value="<?php echo $options['photos_email_address']['tribalpages_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://screencast.com/t/oLXcwK4Tobk" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://tribalpages.com/joinnow.html" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="imgur_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][imgur_checked]"; ?>" <?php echo isset($options['photos_email_address']['imgur_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/imgur.png" width="16" height="16"/><label style="position: relative; top: 1px" for="imgur_checkbox">Imgur email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][imgur_txt]"; ?>"
                    value="<?php echo $options['photos_email_address']['imgur_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://imgur.com/account/settings/activate" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://imgur.com/register" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="fotki_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][fotki_checked]"; ?>" <?php echo isset($options['photos_email_address']['fotki_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/fotki.png" width="16" height="16"/><label style="position: relative; top: 1px" for="fotki_checkbox">Fotki email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_email_address][fotki_txt]"; ?>"
                    value="<?php echo $options['photos_email_address']['fotki_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://screencast.com/t/uVutvPWx3m" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://signup.fotki.com/" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="mobypicture_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_videos_email_address][mobypicture_checked]"; ?>" <?php echo isset($options['photos_videos_email_address']['mobypicture_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/mobypicture.png" width="16" height="16"/><label style="position: relative; top: 1px" for="mobypicture_checkbox" >Mobypicture email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_videos_email_address][mobypicture_txt]"; ?>"
                    value="<?php echo $options['photos_videos_email_address']['mobypicture_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://www.mobypicture.com/account" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://www.mobypicture.com/signup?icn=signup&ici=footer" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
        </table>
    <?php
    }
    
    function setAudioEmailAddress() {
        $options = get_option("{$this->plugin_name}_media_options");
        $plugin_url = trailingslashit( get_bloginfo('wpurl') ).PLUGINDIR.'/'. dirname( plugin_basename(__FILE__) ); ?>
        <table style="margin:0; padding:0">
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="audioo_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[audios_email_address][audioo_checked]"; ?>" <?php echo isset($options['audios_email_address']['audioo_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0; width:175px"><img style="margin: 0 7px -4px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/audioo.png" width="16" height="16"/><label style="position: relative; top: 1px" for="audioo_checkbox">Audioo email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[audios_email_address][audioo_txt]"; ?>"
                    value="<?php echo $options['audios_email_address']['audioo_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://audioo.com/#/pages/faq" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://audioo.com/accounts/register" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
        </table>
    <?php
    }
    
    function setVideoEmailAddress() {
        $options = get_option("{$this->plugin_name}_media_options");
        $plugin_url = trailingslashit( get_bloginfo('wpurl') ).PLUGINDIR.'/'. dirname( plugin_basename(__FILE__) ); ?>
        <table style="margin:0; padding:0">
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="youtube_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[videos_email_address][youtube_checked]"; ?>" <?php echo isset($options['videos_email_address']['youtube_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0; width:175px"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/youtube.png" width="16" height="16"/><label style="position: relative; top: 1px" for="youtube_checkbox" >Youtube email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[videos_email_address][youtube_txt]"; ?>"
                    value="<?php echo $options['videos_email_address']['youtube_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://www.youtube.com/account_mobile_setup" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://www.youtube.com/signup?next=/" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="vimeo_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[videos_email_address][vimeo_checked]"; ?>" <?php echo isset($options['videos_email_address']['vimeo_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/vimeo.png" width="16" height="16"/><label style="position: relative; top: 1px" for="vimeo_checkbox" >Vimeo email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[videos_email_address][vimeo_txt]"; ?>"
                    value="<?php echo $options['videos_email_address']['vimeo_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://vimeo.com/upload/video" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://vimeo.com/join" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
        </table>
        <?php
    }
            
    function setOtherEmailAddress() {
        $options = get_option("{$this->plugin_name}_other_options");
        $plugin_url = trailingslashit( get_bloginfo('wpurl') ).PLUGINDIR.'/'. dirname( plugin_basename(__FILE__) );
        ?>
        <script type="text/javascript">
            jQuery(document).ready(function() {
                jQuery("#form4")[0].reset();
                jQuery("#selectDeselectAll").click(function(){
                    var val = jQuery(this).attr('checked');
					var checkboxes = jQuery("#form4").find(".other_checkbox");
					for(var i=0; i<checkboxes.length; i++ ) {
						jQuery(checkboxes[i])[0].checked = val;
					}
                });
            });
        </script>
        <table style="margin:0; padding:0">
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input id="selectDeselectAll" type="checkbox" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][selectDeselectAll]"; ?>" value="<?php echo $options['otherEmailAddress']['selectDeselectAll']==True?"True":"False" ?>" <?php echo $options['otherEmailAddress']['selectDeselectAll']==True?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><label for="selectDeselectAll"><b>Select/Deselect All</b></label>&nbsp;&nbsp;</td>
                <td></td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="other_checkbox" id="typepad_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][typepad_checked]"; ?>" <?php echo isset($options['otherEmailAddress']['typepad_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/typepad.png" width="16" height="16"/><label style="position: relative; top: 1px" for="typepad_checkbox">Typepad email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][typepad]"; ?>" value="<?php echo isset($options['otherEmailAddress']['typepad'])?$options['otherEmailAddress']['typepad']:''; ?>" style="margin-right:19px;" />
                    &nbsp;&nbsp;<a href="http://screencast.com/t/EiKbpt5z8g" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://www.typepad.com/secure/services/signin?register=1" target="_blank">Link to Sign-up</a></td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="other_checkbox" id="facebook_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][facebook_checked]"; ?>" <?php echo isset($options['otherEmailAddress']['facebook_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/facebook.png" width="16" height="16"/><label style="position: relative; top: 1px" for="facebook_checkbox">Facebook email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][facebook]"; ?>" value="<?php echo isset($options['otherEmailAddress']['facebook'])?$options['otherEmailAddress']['facebook']:''; ?>" style="margin-right:19px;" />
                    &nbsp;&nbsp;<a href="http://m.facebook.com/upload.php?refid=7" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://m.facebook.com/r.php?refid=8" target="_blank">Link to Sign-up</a></td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="other_checkbox" id="bufferapp_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][bufferapp_checked]"; ?>" <?php echo isset($options['otherEmailAddress']['bufferapp_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/linkedin.png" width="16" height="16"/><label style="position: relative; top: 1px" for="bufferapp_checkbox">LinkedIn</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][bufferapp]"; ?>" value="<?php echo isset($options['otherEmailAddress']['bufferapp'])?$options['otherEmailAddress']['bufferapp']:''; ?>" style="margin-right:19px;" />
                    &nbsp;&nbsp;<a href="http://bufferapp.com/guides/email" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://www.linkedin.com/" target="_blank">Link to Sign-up</a></td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="other_checkbox" id="tweetymail_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][tweetymail_checked]"; ?>" <?php echo isset($options['otherEmailAddress']['tweetymail_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/twitter.png" width="16" height="16"/><label style="position: relative; top: 1px" for="tweetymail_checkbox">Twitter</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input size="30" style="margin:8px 8px 8px 21px;" type="text" name="<?php echo "{$this->plugin_name}_other_options[otherEmailAddress][tweetymail]"; ?>" value="<?php echo isset($options['otherEmailAddress']['tweetymail'])?$options['otherEmailAddress']['tweetymail']:''; ?>" style="margin-right:19px;" />
                    &nbsp;&nbsp;<a href="http://tweetymail.com/userguide#post" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://twitter.com/" target="_blank">Link to Sign-up</a></td>
            </tr>
        </table>
        <?php
    }
	
    function setPhotoVideoEmailAddress() {
        $options = get_option("{$this->plugin_name}_media_options");
        $plugin_url = trailingslashit( get_bloginfo('wpurl') ).PLUGINDIR.'/'. dirname( plugin_basename(__FILE__) ); ?>
        <table style="margin:0; padding:0">
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="photobucket_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_videos_email_address][photobucket_checked]"; ?>" <?php echo isset($options['photos_videos_email_address']['photobucket_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0; width: 175px;"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/photobucket.png" width="16" height="16"/><label style="position: relative; top: 1px" for="photobucket_checkbox" >Photobucket email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_videos_email_address][photobucket_txt]"; ?>"
                    value="<?php echo $options['photos_videos_email_address']['photobucket_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://photobucket.com/mobile/upload" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://register.photobucket.com/" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="evernote_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_videos_email_address][evernote_checked]"; ?>" <?php echo isset($options['photos_videos_email_address']['evernote_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/evernote.png" width="16" height="16"/><label style="position: relative; top: 1px" for="evernote_checkbox" >Evernote email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_videos_email_address][evernote_txt]"; ?>"
                    value="<?php echo $options['photos_videos_email_address']['evernote_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="https://www.evernote.com/User.action#summary" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="https://www.evernote.com/Registration.action" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
            <tr>
                <td style="margin:0; padding:0 8px 0 0"><input class="media_checkbox" id="flickr_checkbox" type="checkbox" name="<?php echo "{$this->plugin_name}_media_options[photos_videos_email_address][flickr_checked]"; ?>" <?php echo isset($options['photos_videos_email_address']['flickr_checked'])?"checked":"" ?>/></td>
                <td style="margin:0; padding:0"><img style="margin: 0 7px -3px 0; padding: 0; width:16px; height:16px;" src="<?php echo $plugin_url; ?>/social-buttons/flickr.png" width="16" height="16"/><label style="position: relative; top: 1px" for="flickr_checkbox" >Flickr email</label>&nbsp;&nbsp;</td>
                <td style="margin:0; padding:0"><input style="margin:8px; padding:3px;" size="30" type="text" name="<?php echo "{$this->plugin_name}_media_options[photos_videos_email_address][flickr_txt]"; ?>"
                    value="<?php echo $options['photos_videos_email_address']['flickr_txt']; ?>"/>
                    &nbsp;&nbsp;<a href="http://www.flickr.com/account/uploadbyemail/" target="_blank" >Link to Unique Email</a>
                    &nbsp;&nbsp;<a href="http://www.flickr.com/signup" target="_blank" >Link to Sign-up</a>
                </td>
            </tr>
        </table>
    <?php
    }
    
    function setGeneralSectionText() {
            ?>
    <p>General <?php echo $this->plugin_name2; ?> settings can be set here</p>
            <?php
    }

    function setBlogAccountSectionText() {
            ?>
    <p>Blog account-related <?php echo $this->plugin_name2; ?> settings can be set here</p>
            <?php
    }

    function setMediaAccountSectionText() {
            ?>
    <p>Media account-related <?php echo $this->plugin_name2; ?> settings can be set here</p>
            <?php
    }

    function setOtherAccountSectionText() {
            ?>
    <p>Other accounts</p>
            <?php
    }

    function createSettingsPage() {
        ?>

    <div class="wrap">
            <h2><?php $this->plugin_name2; ?> Settings Page</h2>
            <form action="options.php" method="post" id="form1">
            <?php settings_fields("{$this->plugin_name}_options"); ?>
            <?php do_settings_sections("{$this->plugin_name}_general_page"); ?>
                    <br /><p class="submit"><input name="submit" type="submit"
                            value="<?php esc_attr_e('Save Changes'); ?>" /></p>
            </form>
    </div>
            <?php
    }

    function createBlogOptionsPage() {
        ?>

    <div class="wrap">
            <h2>Blogs</h2>
            <form action="options.php" method="post" id="form2">
            <?php settings_fields("{$this->plugin_name}_blog_options"); ?>
            <?php do_settings_sections("{$this->plugin_name}_blog_page"); ?>
                    <br /><p class="submit"><input name="submit" type="submit"
                            value="<?php esc_attr_e('Save Changes'); ?>" /></p>
            </form>
    </div>
            <?php
    }

    function createMediaOptionsPage() {
        ?>
    <div class="wrap">
            <h2>Media</h2>
            <form action="options.php" method="post" id="form3">
            <?php settings_fields("{$this->plugin_name}_media_options"); ?>
            <?php do_settings_sections("{$this->plugin_name}_media_page"); ?>
                    <br /><p class="submit"><input name="submit" type="submit"
                            value="<?php esc_attr_e('Save Changes'); ?>" /></p>
            </form>
    </div>
            <?php
    }

    function createOtherOptionsPage() {
        ?>
    <div class="wrap">
            <h2>Other</h2>
            <form action="options.php" method="post" id="form4">
            <?php settings_fields("{$this->plugin_name}_other_options"); ?>
            <?php do_settings_sections("{$this->plugin_name}_other_page"); ?>
                    <br /><p class="submit"><input name="submit" type="submit"
                            value="<?php esc_attr_e('Save Changes'); ?>" /></p>
            </form>
    </div>
            <?php
    }
    
    // edit: ian
    // send a generalized email to blogs unlisted in the plugin. Lazy! :)
    function sendGeneralizedEmail($link) {
            $options = get_option("{$this->plugin_name}_options");

            $addresses = $options['generalmail_adresses'];

            if(isset($addresses)){
                    $content = $options['generalmail_content'];
                    $subject = $options['generalmail_subject'];

                    $content = str_replace('[link]',$link,$content);
                    $content = $this->spinner->detect($content, False);

                    $headers = "From: {$options['fromName']} <{$options['fromEmailAddress']}>\r\nContent-type: text/html\r\n";

                    $result = wp_mail( $addresses, $subject, $content, $headers);
            }
    }

    function laEmail($email_address, $content, $headers) {
            $content = $this->spinner->detect($content);
            return wp_mail($email_address, $subject, $content, $headers);
    }

    function email( $post_ID ) {
        $options = get_option("{$this->plugin_name}_options");				

        $postType = get_post_type($post_ID);
        $cont = False;
        
        $postType = get_post_type($post_ID);
        $pagesSet = isset($options['allowToSendFromPages'])?True:False;
        $postsSet = isset($options['allowToSendFromPosts'])?True:False;
		
        if( $postType == 'page' && $pagesSet ) {
            $cont = True;
        } else if( $postType == 'post' && $postsSet ) {
            $cont = True;
        }
        if( !$cont ) {
            return $post_ID;
        }

        $useGlobalPrePostText = get_post_meta($post_ID, "{$this->plugin_name}_use_global_pre_and_post_text", True);
        if( $useGlobalPrePostText!=1 ) {
                $textBefore = get_post_meta($post_ID, "text_before", True);
                $textAfter = get_post_meta($post_ID, "text_after", True);
                $options['emailTextBefore'] = $textBefore;
                $options['emailTextAfter'] = $textAfter;
        }

        $permalink 	= get_permalink($post_ID);
        $siteLink = get_bloginfo("siteurl");
        $customURL = $options['custom_link_url'];
        $customLink = $options['custom_link_text']." ";
        $linkTag = $options['linktag']." ";
		
        $emailBefore=$options['emailTextBefore'];
        $emailAfter=$options['emailTextAfter'];
		
        $post = get_post($post_ID);
        $subject = $post->post_title;
        $content = $post->post_content;
		$gid = $this->checkShortcode($content);
        $galleryPaths = $this->getGalleryPaths($gid);
        $post->post_content = do_shortcode($content);
        $hrefArray = $this->getHREFs($post->post_content);
        $validHREFs = $this->getValidHREF($hrefArray, True,"");
		
        $plainContent = strip_tags($emailBefore.$post->post_content.$emailAfter);
        $headersPlain = "From: {$options['fromName']} <{$options['fromEmailAddress']}>\r\nContent-type: text/plain\r\n";
        $headersPlainISO = "From: {$options['fromName']} <{$options['fromEmailAddress']}>\r\nContent-type: text/plain; charset=ISO-8859-1\r\n";
		
        $htmlContent = $emailBefore.$post->post_content.$emailAfter;
        $headersHTML = "From: {$options['fromName']} <{$options['fromEmailAddress']}>\r\nContent-type: text/html\r\n";
		
        $contentHREFedited = $post->post_content;
        if(is_array($validHREFs ) ) {
            if(!empty($validHREFs) ) {
                $all = "";
                foreach($validHREFs as $vh ) {
                    if(!empty($all)) {
                        $all.=" ";
                    }
                    $all.=$vh;
                    $contentHREFedited = $this->removeValidHREF($contentHREFedited, $vh);
                }
                if(!empty($all)) {
                    // $content = $all." ".$content;
                }
            }
        }

        if($options['linkToShow'] == "sitetitlelink"){
            $plainLink = $siteLink;
            $htmlLink = "{$linkTag} <a href='{$siteLink}'>{$subject}</a>";
        } else if ($options['linkToShow'] == "posttitlelink"){
            $plainLink = $permalink;
            $htmlLink = "{$linkTag} <a href='{$permalink}'>{$subject}</a>";
        } else if ($options['linkToShow'] == "sitetextlink"){
            $plainLink = $siteLink;
            $htmlLink = "{$linkTag} <a href='{$siteLink}'>{$options['sitetextlinkfield']}</a>";
        } else if ($options['linkToShow'] == "posttextlink"){
            $plainLink = $permalink;
            $htmlLink = "{$linkTag} <a href='{$permalink}'>{$options['posttextlinkfield']}</a>";
        } else if ($options['linkToShow'] == "homelink"){
            $plainLink = $siteLink;
            $htmlLink = "{$linkTag} <a href='{$siteLink}'>{$siteLink}</a>";
        } else if ($options['linkToShow'] == "postlink"){
            $plainLink = $permalink;
            $htmlLink = "{$linkTag} <a href='{$permalink}'>{$permalink}</a>";
        } else if ($options['linkToShow'] == "customlink"){
            $plainLink = $customURL;
            $htmlLink = "{$linkTag} <a href='{$customURL}'>{$customLink}</a>";
        } else if ($options['linkToShow'] == "randomlink"){
            $randomlinks = $options['random'];
            if(!is_array($randomlinks)) {
                $randomlinks = array();
            }
            if( !empty($randomlinks) ) {
                $randomlinks2 = array();
                foreach( $randomlinks as $key=>$value) {
                    $randomlinks2[] = $key;
                }
                if( !empty($randomlinks2) ) {
                    shuffle($randomlinks2);
                    $randomtype = $randomlinks2[0];
                    
                    if( $randomtype == 'site_title_link_ch') {
                        $randomURL = $siteLink;
                        $randomtext = $subject;
                    } else if( $randomtype == 'post_title_link_ch' ) {
                        $randomURL = $permalink;
                        $randomtext = $subject;
                    } else if( $randomtype == 'site_text_link_ch' ) {
                        $randomURL = $siteLink;
                        $randomtext = $options['sitetextlinkfield'];
                    } else if( $randomtype == 'post_text_link_ch' ) {
                        $randomURL = $permalink;
                        $randomtext = $options['posttextlinkfield'];
                    } else if( $randomtype == 'home_url_ch' ) {
                        $randomURL = $siteLink;
                        $randomtext = $siteLink;
                    } else if( $randomtype == 'post_url_ch' ) {
                        $randomURL = $permalink;
                        $randomtext = $permalink;
                    } else if( $randomtype == 'custom_link_ch' ) {
                        $randomURL = $customURL;
                        $randomtext = $customLink;
                    } else if( $randomtype == 'no_link_ch' ) {
                        $randomURL = "";
                        $randomtext = "";
                        
                    }
                }
            }
            
            if( $randomtype == 'no_link_ch' ) {
            } else {
                $plainLink = $randomURL;
                $htmlLink = "{$linkTag} <a href='{$randomURL}'>{$randomtext}</a>";
            }
        } else if($options['linkToShow'] == "nolink") {
        }

        $mediaPlainContent = $linkTag.$plainLink." ".$plainContent;
        $mediaPlainContent2 = $linkTag.$plainLink."\r\n".$plainContent;
        $mediaHTMLContent = $htmlLink." <br /> ".$htmlContent;

        $blogHTMLContent2 = "{$htmlContent}\r\n".$plainLink;
        $blogPlainContent = "{$plainContent} ".$plainLink;

        $hyvesContent = html_entity_decode($hyvescontent, ENT_QUOTES, "UTF-8");
        
        $attachments = array();

        $photos_valid_href = $this->getValidHREF($hrefArray, False, "photos");
		
        if( !empty($galleryPaths) ) {
            $mediaHTMLContent = $this->removeHREF($mediaHTMLContent, $galleryPaths);
        } else {
            $mediaHTMLContent = $this->removeValidHREF($mediaHTMLContent, $photos_valid_href);
            if( $photos_valid_href != '' ) {
                $galleryPaths[] = $photos_valid_href;
            }
        }
		
        $videos_valid_href = $this->getValidHREF($hrefArray, False, "videos");
        $mediaHTMLContent = $this->removeValidHREF($mediaHTMLContent, $videos_valid_href);
        
        $audios_valid_href = $this->getValidHREF($hrefArray, False, "audios");
        $mediaHTMLContent = $this->removeValidHREF($mediaHTMLContent, $audios_valid_href);
        
        $optionsMedia = get_option("{$this->plugin_name}_media_options");
        $attachmentsMedia = array();
		
        if( !is_array($galleryPaths) ) {
            $galleryPaths = array();
        }
        $maxChars = trim($options['characters']);
        if(is_numeric($maxChars) ) {
            $maxChars = intval($maxChars);
        } else {
            $maxChars = -1;
        }
        if(!empty($galleryPaths)) {
            foreach( $galleryPaths as $gval ) {
				if( !empty($gval) ) {
					copy($gval, '/tmp/' . basename($gval));
					$attachments[] = '/tmp/' . basename($gval);
				}
            }
            $attachmentsMedia = $attachments;

            $photos_email_address_arr = $optionsMedia['photos_email_address'];

            $lef = "";
			
            if(isset($photos_email_address_arr['picasa_checked'])) {
                //plain text + normal links - subject
                $picasa_email_address = $photos_email_address_arr['picasa'];
                $picasa_bool = wp_mail( $picasa_email_address, "".$this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $headersHTML, $attachments );
                $lef.="picasa<br />";
            }


            if(isset($photos_email_address_arr['lockerz_checked'])) {
				$lockerzContent = $this->generateSpunAndClipContent($mediaPlainContent,$maxChars);
                //plain text - subject
                $lockerz_email_address = $photos_email_address_arr['lockerz_txt'];
                $lockerz_bool = wp_mail( $lockerz_email_address, $lockerzContent, $lockerzContent, $headersHTML, $attachments );
                $lef.="lockerz<br />";
            }
            
            if(isset($photos_email_address_arr['imageevent_checked'])) {
                $imageEventContent = $this->generateSpunAndClipContent($mediaPlainContent,$maxChars);
                //none
                $imageevent_email_address = $photos_email_address_arr['imageevent_txt'];
                $imageevent_bool = wp_mail( $imageevent_email_address, $imageEventContent, $imageEventContent, $headers, $attachments );
                $lef.="imageevent<br />";
            }
                
            if(isset($photos_email_address_arr['keepandshare_checked'])) {
                //html text + text links - subject
                $keepandshare_email_address = $photos_email_address_arr['keepandshare_txt'];
                $keepandshare_bool = wp_mail( $keepandshare_email_address, $this->generateSpunAndClipContent($mediaHTMLContent,$maxChars), $this->generateSpunAndClipContent($mediaHTMLContent,$maxChars), $headersHTML, $attachments );
                $lef.="keepandshare<br />";
            }
            
            if(isset($photos_email_address_arr['sugarsync_checked'])) {
                //none
                $sugarsync_email_address = $photos_email_address_arr['sugarsync_txt'];
                $sugarsync_bool = wp_mail( $sugarsync_email_address, $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $headersHTML, $attachments );
                $lef.="sugarsync<br />";
            }
            
            if(isset($photos_email_address_arr['kodakgallery_checked'])) {
                //none - jpeg/jpg only
                $kodakgallery_email_address = $photos_email_address_arr['kodakgallery_txt'];
                $kodakgallery_bool = wp_mail( $kodakgallery_email_address, $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $headersHTML, $attachments );
                $lef.="kodakgallery<br />";
            }
            
            if(isset($photos_email_address_arr['twitpic_checked'])) {
                //plain text + normal link - subject
                $twitpic_email_address = $photos_email_address_arr['twitpic_txt'];
                $twitpic_bool = wp_mail( $twitpic_email_address, $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $headersHTML, $attachments );
                $lef.="twitpic<br />";
            }
            
            if(isset($photos_email_address_arr['tribalpages_checked'])) {
                //plain text - subject - description
                $tribalpages_email_address = $photos_email_address_arr['tribalpages_txt'];
                $tribalpages_bool = wp_mail( $tribalpages_email_address, $subject, $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $headersHTML, $attachments );
                $lef.="tribalpages<br />";
            }
            
            if(isset($photos_email_address_arr['imgur_checked'])) {
                //none
                $imgur_email_address = $photos_email_address_arr['imgur_txt'];
                $imgur_bool = wp_mail( $imgur_email_address, $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $headersHTML, $attachments );
                $lef.="imgur<br />";
            }
            
            if(isset($photos_email_address_arr['fotki_checked'])) {
                //plain text + normal link - subject
                $fotki_email_address = $photos_email_address_arr['fotki_txt'];
                $fotki_bool = wp_mail( $fotki_email_address, $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $headersHTML, $attachments );
                $lef.="fotki<br />";
            }
            
            $photos_videos_email_address_arr = $optionsMedia['photos_videos_email_address'];
            if(isset($photos_videos_email_address_arr['photobucket_checked'])) {
                //no
                $photobucket_email_address = $photos_videos_email_address_arr['photobucket_txt'];
                $photobucket_bool = wp_mail( $photobucket_email_address, $this->generateSpunAndClipContent($mediaHTMLContent,$maxChars), $this->generateSpunAndClipContent($mediaHTMLContent,$maxChars), $headersHTML, $attachments );
                $lef.="photobucket<br />";
            }
            
            if(isset($photos_videos_email_address_arr['evernote_checked'])) {
				//html + text links - subject - description
                $evernote_email_address = $photos_videos_email_address_arr['evernote_txt'];
                $evernote_bool = wp_mail( $evernote_email_address, $subject, $this->generateSpunAndClipContent($mediaHTMLContent,$maxChars), $headersHTML, $attachments );
                $lef.="evernote<br />";
            }
            
            if(isset($photos_videos_email_address_arr['flickr_checked'])) {
				//plain text + text links - subject - description
                $flickr_email_address = $photos_videos_email_address_arr['flickr_txt'];
                $flickr_bool = wp_mail( $flickr_email_address, $subject, $this->generateSpunAndClipContent($mediaPlainContent,$maxChars), $headersHTML, $attachments );
                $lef.="flickr<br />";
            }
            
            if(isset($photos_videos_email_address_arr['mobypicture_checked'])) {
                $mobyPictureContent = $this->generateSpunAndClipContent($mediaPlainContent2,$maxChars);
                //plain text header + plaintext + normal links - subject - description
                $mobypicture_email_address = $photos_videos_email_address_arr['mobypicture_txt'];
                $mobypicture_bool = wp_mail( $mobypicture_email_address, $subject, $mobyPictureContent, $headersPlain, $attachments );
                $lef.="mobypicture<br />";
            }
            
        } else if(strcasecmp('',  $videos_valid_href)) {
            copy($videos_valid_href, '/tmp/' . basename($videos_valid_href));
            $attachments = array('/tmp/' . basename($videos_valid_href));
            $attachmentsMedia = $attachments;
            
            $videos_email_address_arr = $optionsMedia['videos_email_address'];
            if(isset($videos_email_address_arr['vimeo_checked'])) {
                //plain text header + plaintext + normal links - subject - description
                $vimeo_email_address = $videos_email_address_arr['vimeo_txt'];
                $vimeo_bool = wp_mail($vimeo_email_address, $subject, html_entity_decode($this->generateSpunAndClipContent($mediaPlainContent2,$maxChars)), $headersPlain, $attachments);
                $lef.="vimeo<br />";
            }
            
            if(isset($videos_email_address_arr['youtube_checked'])) {
                //plain text + text links - subject - description
                $youtube_email_address = $videos_email_address_arr['youtube_txt'];
                $youtube_bool = wp_mail( $youtube_email_address, $subject, $this->generateSpunAndClipContent($mediaPlainContent2,$maxChars), $headersPlain, $attachments );
                $lef.="youtube<br />";
            }
            
            $photos_videos_email_address_arr = $options2['photos_videos_email_address'];
            if(isset($photos_videos_email_address_arr['photobucket_checked'])) {
                //no
                $photobucket_email_address = $photos_videos_email_address_arr['photobucket_txt'];
                $photobucket_bool = wp_mail( $photobucket_email_address, $photoBucketContent, $photoBucketContent, $headersHTML, $attachments );
                $lef.="photobucket<br />";
            }
            
            if(isset($photos_videos_email_address_arr['evernote_checked'])) {
                //html + text links - subject - description
                $evernote_email_address = $photos_videos_email_address_arr['evernote_txt'];
                $evernote_bool = wp_mail( $evernote_email_address, $subject, $this->generateSpunAndClipContent($mediaHTMLContent,$maxChars), $headersHTML, $attachments );
                $lef.="evernote<br />";
            }
            
            if(isset($photos_videos_email_address_arr['flickr_checked'])) {
                //plain text + text links - subject - description
                $flickr_email_address = $photos_videos_email_address_arr['flickr_txt'];
                $flickr_bool = wp_mail( $flickr_email_address, $subject, $this->generateSpunAndClipContent($mediaPlainContent2,$maxChars), $headersHTML, $attachments );
                $lef.="flickr<br />";
            }
        } else {
		}
        
        if(strcasecmp('',  $audios_valid_href)) {
            copy($audios_valid_href, '/tmp/' . basename($audios_valid_href));
            $attachments = array('/tmp/' . basename($audios_valid_href));
            if(!strcasecmp('', $attachments2)) {
                $attachmentsMedia = $attachments;
            }

            $audios_email_address_arr = $optionsMedia['audios_email_address'];

            if( isset($audios_email_address_arr['audioo_checked']) ) {
                $audioo_email_address = $audios_email_address_arr['audioo_txt'];
                $audioo_bool = wp_mail( $audioo_email_address, $this->generateSpunAndClipContent($mediaHTMLContent,$maxChars), $this->generateSpunAndClipContent($mediaHTMLContent,$maxChars), $headersHTML, $attachmentsMedia );
                $lef.="audioo<br />";
            }
        }

        $options3 = get_option("{$this->plugin_name}_blog_options");
        
        $tumblr_email = ($options3['blogEmailAddress']['tumblr_checked']) ? $options3['blogEmailAddress']['tumblr'] : "";
        if(!empty($tumblr_email)) {
            $link = $this->spinner->detect($htmlLink);
            wp_mail( $tumblr_email, $subject, preg_replace('/[\x00-\x1F\x80-\xFF]/','',$this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link)))."<br />".$link, "From: {$options['fromName']} <{$options['fromEmailAddress']}>\r\nMIME-Version: 1.0\r\nContent-Type: text/html; charset=UTF-8\r\n");
        }
        $livejournal_email = ($options3['blogEmailAddress']['livejournal_checked']) ? $options3['blogEmailAddress']['livejournal'] : "";
        if(!empty($livejournal_email)) {
            $link = $this->spinner->detect($htmlLink);
             wp_mail( $livejournal_email, $subject, $this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link))."<br />".$link, $headersHTML);
        }
        $blogger_email = ($options3['blogEmailAddress']['blogger_checked']) ? $options3['blogEmailAddress']['blogger'] : "";
        if(!empty($blogger_email)) {
            $link = $this->spinner->detect($htmlLink);
             wp_mail( $blogger_email, $subject, $this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link))."<br />".$link, $headersHTML);
        }
        $onsugar_email = ($options3['blogEmailAddress']['onsugar_checked']) ? $options3['blogEmailAddress']['onsugar'] : "";
        if(!empty($onsugar_email)) {
            $ons = wp_mail( $onsugar_email, $subject, $this->generateSpunAndClipContent($plainContent, $maxChars-strlen(" ".$plainLink))." ".$plainLink, $headersPlain);
        }
        $ipernity_email = ($options3['blogEmailAddress']['ipernity_checked']) ? $options3['blogEmailAddress']['ipernity'] : "";
        if(!empty($ipernity_email)) {
            $link = $this->spinner->detect($htmlLink);
             wp_mail( $ipernity_email, $subject, $this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link))."<br />".$link, $headersHTML);
        }
        $multiply_email = ($options3['blogEmailAddress']['multiply_checked']) ? $options3['blogEmailAddress']['multiply'] : "";
        if(!empty($multiply_email)) {
            $link = $this->spinner->detect($htmlLink);
             wp_mail( $multiply_email, $subject, $this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link))."<br />".$link, $headersHTML);
        }
        $myOpera_email = ($options3['blogEmailAddress']['myopera_checked']) ? $options3['blogEmailAddress']['myopera'] : "";
        if(!empty($myOpera_email)) {
            $link = $this->spinner->detect($htmlLink);
             wp_mail( $myOpera_email, $subject, $this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link))."<br />".$link, $headersPlain);
        }
        $hyves_email = ($options3['blogEmailAddress']['hyves_checked']) ? $options3['blogEmailAddress']['hyves']."," : "";
        if(!empty($hyves_email)) {
            wp_mail( $hyves_email, $subject, $this->generateSpunAndClipContent($emailBefore.$contentHREFedited.$emailAfter, $maxChars), $headersPlain, $attachmentsMedia);
        }
        $evernote_blog_email = ($options3['blogEmailAddress']['evernote_checked']) ? $options3['blogEmailAddress']['evernote'] : "";
        if(!empty($evernote_blog_email)) {
            $link = $this->spinner->detect($htmlLink);
             wp_mail( $evernote_blog_email, $subject, $this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link))."<br />".$link, $headersHTML);
        }
        $posterous_email = ($options3['blogEmailAddress']['posterous_checked']) ? $options3['blogEmailAddress']['posterous'] : "";
        if(!empty($posterous_email)) {
            $link = $this->spinner->detect($htmlLink);
             wp_mail( $posterous_email, $subject, $this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link))."<br />".$link, $headersHTML);
        }
		
        $wordpress_email = ($options3['blogEmailAddress']['wordpress_checked']) ? $options3['blogEmailAddress']['wordpress'] : "";
        if(!empty($wordpress_email)) {
            $link = $this->spinner->detect($htmlLink);
             wp_mail( $wordpress_email, $subject, $this->generateSpunAndClipContent($htmlContent, $maxChars-strlen("<br />".$link))."<br />".$link, $headers);
        }		
        
        $optionsOther = get_option("{$this->plugin_name}_other_options");
		$typePad_email = ($optionsOther['otherEmailAddress']['typepad_checked']) ? $optionsOther['otherEmailAddress']['typepad'] : "";
        if(!empty($typePad_email)) {
             wp_mail( $typePad_email, $subject, $this->generateSpunAndClipContent($plainContent, $maxChars-strlen(" ".$plainLink))." ".$plainLink, $headersPlain, $attachmentsMedia);
        }
        $facebook_email = ($optionsOther['otherEmailAddress']['facebook_checked']) ? $optionsOther['otherEmailAddress']['facebook'] : "";
        if(!empty($facebook_email)) {
            $facebookOtherContent = $this->generateSpunAndClipContent($plainContent, $maxChars-strlen(" ".$plainLink))." ".$plainLink;
            $facebook_result = wp_mail( $facebook_email, $facebookOtherContent,"", $headersPlain);
        }
        $bufferapp_email = ($optionsOther['otherEmailAddress']['bufferapp_checked']) ? $optionsOther['otherEmailAddress']['bufferapp'] : "";
        if(!empty($bufferapp_email)) {
            //max chars allowed = 250
            $maxLen = 250;
            $maxLen = $maxLen-strlen(" ".$plainLink);
            $blogBufferPlainContent = $this->spinner->detect($plainContent, False);
            $blogBufferPlainContentLen = strlen($blogBufferPlainContent);
            if( $blogBufferPlainContentLen > $maxLen ) {
                $blogBufferPlainContent = substr($blogBufferPlainContent, 0, $maxLen);
            }
            $blogBufferPlainContent.=" ".$plainLink;
            $bufferapp_result = wp_mail( $bufferapp_email, $blogBufferPlainContent, "", $headersPlain, $attachmentsMedia);
        }
		
        $tweetymail_email = ($optionsOther['otherEmailAddress']['tweetymail_checked']) ? $optionsOther['otherEmailAddress']['tweetymail'] : "";
        if(!empty($tweetymail_email)) {
            //max chars allowed = 140
            $maxLen = 140;
            $maxLen = $maxLen-strlen(" ".$plainLink);
            $blogTweetyMailPlainContent = $this->spinner->detect($plainContent, False);
            $blogTweetyMailPlainContentLen = strlen($blogTweetyMailPlainContent);
            if( $blogTweetyMailPlainContentLen > $maxLen ) {
                $blogTweetyMailPlainContent = substr($blogTweetyMailPlainContent, 0, $maxLen);
            }
            $blogTweetyMailPlainContent.=" ".$plainLink;
            $tweetymail_result = wp_mail( $tweetymail_email, "", $blogTweetyMailPlainContent, $headersPlain);
        }
		
        if($attachments && strcasecmp('',  $photos_valid_href) != 0) {
            @unlink('/tmp/' . basename($photos_valid_href));
        }
        if($attachments && strcasecmp('',  $videos_valid_href) != 0) {
            @unlink('/tmp/' . basename($videos_valid_href));
        }
        if($attachments && strcasecmp('',  $audios_valid_href) != 0) {
            @unlink('/tmp/' . basename($audios_valid_href));
        }

        return  $post_ID;
    }

    function generateSpunAndClipContent($content='', $maxChars='', $spin = True) {
        
        if( $spin ) {
            $content = $this->spinner->detect($content, False);
        }
        if( is_numeric($maxChars) ) {
            $lengthPlain = strlen($content);
            if( $lengthPlain > $maxChars && $maxChars >= 0 ) {
                $content = substr($content, 0, $maxChars);
            }
        }
        return $content;
    }

    function getGalleryPaths( $id='' ) {
        if( !is_numeric($id) ) {
            return array();
        }
        global $wpdb;
        $query = "SELECT CONCAT(path,'/',filename) as 'path' FROM wp_ngg_gallery, wp_ngg_pictures WHERE gid=galleryid and gid=$id";
        $rs = $wpdb->get_results($query);

        $retval = array();
        
        foreach( $rs as $val ) {
            $url = get_bloginfo('wpurl');
            if(strripos($url, "/")+1 != strlen($url)) {
                $url .= "/";
            }
            $retval[] = $url . $val->path;
        }
        return $retval;
    }
    
    function checkShortcode($content='', $shortcode='nggallery') {
        $pattern = get_shortcode_regex();
        preg_match_all( '/'. $pattern .'/s', $content, $matches );
        if( is_array( $matches ) && array_key_exists( 2, $matches ) && array_key_exists( 3, $matches ) && in_array( $shortcode, $matches[2] ) ) {
            foreach( $matches[2] as $key=>$val) {
                if( $val == $shortcode) {
                    $param = $matches[3][$key];
                    $param_e = explode("=", str_replace(" ", "", $param));
                    if( $param_e ) {
                        if( count($param_e)>=2 ) {
                            $galleryId = $param_e[1];
                            return $galleryId;
                        }
                    }
                }
            } 
        }
    }
    
    function getHREFArray($string_arg) {

        $string = $string_arg;
        $string = str_replace("href=\"", "Ã‚Â¡", $string);
        $string = str_replace("\">", "Ã‚Â¡", $string);
        $string = str_replace("</a>", "Ã‚Â¡", $string);
        $tok = strtok($string, "Ã‚Â¡");
        $rep = 1;
        $href_array = array();

        while ($tok) {
            if (substr($tok, 0, 7) == "http://" || substr($tok, 0, 6) == "ftp://" || substr($tok, 0, 4) == "<img")  {
                if(  substr($tok, 0, 4) == "<img" ) {
                    $tok = str_replace("'", '"', $tok);
/*                    $doc=new DOMDocument();
                    $doc->loadHTML($tok);
                    $xml=simplexml_import_dom($doc); // just to make xpath more simple
                    $images=$xml->xpath('//img');
                    foreach ($images as $img) {
                        echo $img['src'];
                    }*/

                    preg_match_all("/src=(\"|')([^\"]*)(\"|')/",$tok, $matches);
                    
                    if ( isset( $matches ) )
                    {
                        foreach ($matches as $match) 
                        {
                            if(strpos($match[0], "src")!==false)
                            {
                                $res = explode("\"", $match[0]);
                                $res1 = trim($res[1]);
                                if(substr($res1, 0, 7) == "http://") {
                                    $href_array[] = $res1;
                                }
                            }
                        }
                    }
                } else {
                    $href_array[] = $tok;
                }
            }
            $tok = strtok("Ã‚Â¡");
            $rep++;
        }
        return $href_array;
    }

    function getValidHREF($href_array_arg, $all, $type) {
        $blank_string = "";

	if(is_array($href_array_arg)){
        foreach ($href_array_arg as $href_value) {
            $href_extn = substr(strrchr($href_value,'.'),1);
            $valid = False;
            if( $type == 'photos' || $all) {
                if (strcasecmp ( $href_extn , "jpg" ) == 0 ||
                    strcasecmp ( $href_extn , "jpeg" ) == 0 ||
                    strcasecmp ( $href_extn , "tiff" ) == 0 ||
                    strcasecmp ( $href_extn , "png" ) == 0 ||
                    strcasecmp ( $href_extn , "gif" ) == 0 ) {
                    $valid = True;
                }
            } else if( $type=='videos'  || $all) {
                if( strcasecmp ( $href_extn , "mp4" ) == 0 ||
                    strcasecmp ( $href_extn , "m4v" ) == 0 ||
                    strcasecmp ( $href_extn , "mov" ) == 0 ||
                    strcasecmp ( $href_extn , "wmv" ) == 0 ||
                    strcasecmp ( $href_extn , "avi" ) == 0 ||
                    strcasecmp ( $href_extn , "mpg" ) == 0 ||
                    strcasecmp ( $href_extn , "ogv" ) == 0 ||
                    strcasecmp ( $href_extn , "3gp" ) == 0 ||
                    strcasecmp ( $href_extn , "3g2" ) == 0) {
                    $valid = True;
                }
            } else if( $type=='audios'  || $all) {
                if( strcasecmp ( $href_extn , "mp3" ) == 0 ||
                    strcasecmp ( $href_extn , "m4a" ) == 0 ||
                    strcasecmp ( $href_extn , "ogg" ) == 0 ||
                    strcasecmp ( $href_extn , "wma" ) == 0 ||
                    strcasecmp ( $href_extn , "wav" ) == 0 ) {
                    $valid = True;
                }
            }
            if( $valid ) {
                if( !$all ) {
                    $options = get_option("{$this->plugin_name}_options");
                    $filesize = trim($options['file_size']);
                    if( !is_numeric($filesize)) {
                        $filesize = 20;
                        $options['file_size'] = $filesize;
                        update_option("{$this->plugin_name}_options", $options);
                    } else {
                        if( $filesize < 1 ) {
                            $filesize = 20;
                            $options['file_size'] = $filesize;
                            update_option("{$this->plugin_name}_options", $options);
                        }
                    }
                    $filesize = 1024 * 1024 * $filesize;
                    if ($this->remoteFileSize($href_value) <= $filesize) {
                        return $href_value;
                    }
                } else {
                    $media_arr[] = $href_value;
                }
            }
        }
        }
        if( !$all ) {
            return $blank_string;
        } else {
            return $media_arr;
        }
    }

    function removeHREF( $text, $href_arr ) {
        $text2 = stripslashes($text);

        if(!preg_match_all("/(<a.*>)(.*)(<\/a>)/ismU",$text2,$matches,PREG_SET_ORDER)){
            $text;
        }

        foreach($matches as $key => $value){
            
            preg_match("/href\s*=\s*[\'|\"]\s*(.*)\s*[\'|\"]/i",$value[1],$href);
            if((substr($href[1],0,7)!="http://" && substr($href[1],0,8)!="https://") ){
                unset($matches[$key]);
            }else{
                $temp_href = $href[1];
                $arr = explode(" ", $temp_href);
                if( $arr ) {
                    if( !empty($arr) ) {
                        $temp_href = $arr[0];
                        $temp_href = str_replace("\"","",$temp_href);
                        if(in_array($temp_href, $href_arr)) {
                            $text2 = str_replace($matches[$key][0],"",$text2);
                        }
                    }
                }
            }
        }
        return $text2;
    }
    
    function removeValidHREF($content_arg, $valid_href_arg) {
            $return_content = $content_arg;
            $regex_valid_href_arg = str_replace("/", "\/", $valid_href_arg);

            if (preg_match('/\<a.+?href\=[\"|\']' . $regex_valid_href_arg . "\s*(.*)\s*" . '[\"|\'].?\>(.+?)<\/a\>/', $return_content, $matches) == 1 ) {
                    $tagless_anchor = $matches[2];

                    if(preg_match('/<img.+?>/', $tagless_anchor) == 1 ) {
                            $tagless_anchor = '';
                    }
                    $tagless_content = preg_replace('/\<a[^<>]+?href\=[\"|\']' . $regex_valid_href_arg . '[\"|\'].?\>(.+?)<\/a\>/', $tagless_anchor, $return_content);
                    return $tagless_content;
            } else {
                    return $return_content;
            }
    }

    function remoteFileSize($url, $user = "", $pw = "") {
            ob_start();
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_HEADER, 1);
            curl_setopt($ch, CURLOPT_NOBODY, 1);

            if(!empty($user) && !empty($pw)) {
                    $headers = array('Authorization: Basic ' . base64_encode("$user:$pw"));
                    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            }

            $ok = curl_exec($ch);
            curl_close($ch);
            $head = ob_get_contents();
            ob_end_clean();

            $regex = '/Content-Length:\s([0-9].+?)\s/';
            $count = preg_match($regex, $head, $matches);

            return isset($matches[1]) ? $matches[1] : "unknown";
    }

    function validate($input) {
            return $input;
    }

}
?>